import typing as t
import typing_extensions as te
import typing
from ..datastructures import CombinedMultiDict as CombinedMultiDict, EnvironHeaders as EnvironHeaders, FileStorage as FileStorage, ImmutableMultiDict as ImmutableMultiDict, MultiDict as MultiDict, iter_multi_items as iter_multi_items
from ..formparser import FormDataParser as FormDataParser, default_stream_factory as default_stream_factory
from ..sansio.request import Request as _SansIORequest
from ..utils import cached_property as cached_property, environ_property as environ_property
from ..wsgi import get_input_stream as get_input_stream
from _typeshed.wsgi import WSGIApplication as WSGIApplication, WSGIEnvironment as WSGIEnvironment
from typing import Any
from werkzeug.exceptions import BadRequest as BadRequest

class Request(_SansIORequest):
    max_content_length: t.Optional[int] = ...
    max_form_memory_size: t.Optional[int] = ...
    form_data_parser_class: t.Type[FormDataParser] = ...
    disable_data_descriptor: t.Optional[bool] = ...
    environ: WSGIEnvironment
    shallow: bool
    def __init__(self, environ: WSGIEnvironment, populate_request: bool=..., shallow: bool=...) -> None: ...
    @classmethod
    def from_values(cls, *args: t.Any, **kwargs: t.Any) -> Request: ...
    @classmethod
    def application(cls, f: t.Callable[[Request], WSGIApplication]) -> WSGIApplication: ...
    @property
    def want_form_data_parsed(self) -> bool: ...
    def make_form_data_parser(self) -> FormDataParser: ...
    def close(self) -> None: ...
    def __enter__(self) -> Request: ...
    def __exit__(self, exc_type: Any, exc_value: Any, tb: Any) -> None: ...
    def stream(self) -> t.IO[bytes]: ...
    input_stream: Any = ...
    def data(self) -> bytes: ...
    @typing.overload
    def get_data(self, cache: bool=..., as_text: te.Literal[False]=..., parse_form_data: bool=...) -> bytes: ...
    @typing.overload
    def get_data(self, cache: bool=..., as_text: te.Literal[True]=..., parse_form_data: bool=...) -> str: ...
    def form(self) -> ImmutableMultiDict[str, str]: ...
    def values(self) -> CombinedMultiDict[str, str]: ...
    def files(self) -> ImmutableMultiDict[str, FileStorage]: ...
    @property
    def script_root(self) -> str: ...
    def url_root(self) -> str: ...
    remote_user: Any = ...
    is_multithread: Any = ...
    is_multiprocess: Any = ...
    is_run_once: Any = ...
    json_module: Any = ...
    @property
    def json(self) -> t.Optional[t.Any]: ...
    def get_json(self, force: bool=..., silent: bool=..., cache: bool=...) -> t.Optional[t.Any]: ...
    def on_json_loading_failed(self, e: ValueError) -> t.Any: ...

class StreamOnlyMixin:
    def __init__(self, *args: t.Any, **kwargs: t.Any) -> None: ...

class PlainRequest(StreamOnlyMixin, Request):
    def __init__(self, *args: t.Any, **kwargs: t.Any) -> None: ...
